unit SystemInfoUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, ToolWin, ImgList, Menus, Buttons,
  IpHlpApi, IpTypes, IpIfConst;

type
  TSystemInfoForm = class(TForm)
    ImageList1: TImageList;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    HostNameLabel: TLabel;
    Label4: TLabel;
    NodeTypeLabel: TLabel;
    Label5: TLabel;
    NetBIOSScopeLabel: TLabel;
    Label7: TLabel;
    IPRoutingLabel: TLabel;
    Label6: TLabel;
    WINSProxyLabel: TLabel;
    Label8: TLabel;
    NetBIOSResolutionLabel: TLabel;
    TabSheet3: TTabSheet;
    Panel3: TPanel;
    DNSListBox: TListBox;
    ScrollBox1: TScrollBox;
    Label10: TLabel;
    Label11: TLabel;
    DescriptionLabel: TLabel;
    PhysicaladdressLabel: TLabel;
    Label12: TLabel;
    AdapterTypeLabel: TLabel;
    AdapterNameLabel: TLabel;
    Label15: TLabel;
    Label13: TLabel;
    DHCPLabel: TLabel;
    Label16: TLabel;
    GatewayLabel: TLabel;
    DHCPServerLabel: TLabel;
    Label19: TLabel;
    Label18: TLabel;
    PrimaryWINSLabel: TLabel;
    SecondaryWINSLabel: TLabel;
    Label21: TLabel;
    IPListView: TListView;
    Panel1: TPanel;
    AdapterCB: TComboBox;
    procedure PageControl1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure GetIPInfo;
  public
    { Public declarations }
  end;

var
  SystemInfoForm: TSystemInfoForm;

implementation

{$R *.DFM}

procedure TSystemInfoForm.PageControl1Change(Sender: TObject);
begin
 if PageControl1.ActivePageIndex=0 then
  GetIPInfo;
end;

procedure TSystemInfoForm.GetIPInfo;
var
 FixedInfoSize, Err:DWORD;
 pFixedInfo:PFIXED_INFO;
 pAddrStr:PIP_ADDR_STRING;
begin
 FixedInfoSize:=0;
 Err:=GetNetworkParams(nil, FixedInfoSize);

 if (Err<>0) and (Err<>ERROR_BUFFER_OVERFLOW) then
  begin
   HostNameLabel.Caption:='Error';
   exit;
  end;

 pFixedInfo:=PFIXED_INFO(GlobalAlloc(GPTR, FixedInfoSize));
 GetNetworkParams(pFixedInfo, FixedInfoSize);

 HostNameLabel.Caption:=StrPas(pFixedInfo.HostName);

 DNSListBox.Items.Clear;
 DNSListBox.Items.Add(StrPas(pFixedInfo.DnsServerList.IpAddress.S));

 pAddrStr:=pFixedInfo.DnsServerList.Next;

 while (pAddrStr<>nil) do
  begin
    DNSListBox.Items.Add(StrPas(pAddrStr.IpAddress.S));
   pAddrStr:=pAddrStr.Next;
  end;

 case pFixedInfo.NodeType of
  1: NodeTypeLabel.Caption:='Broadcast';
  2: NodeTypeLabel.Caption:='Peer to peer';
  4: NodeTypeLabel.Caption:='Mixed';
  8: NodeTypeLabel.Caption:='Hybrid';
 end;

 NetBIOSScopeLabel.Caption:=pFixedInfo.ScopeId;

 if pFixedInfo.EnableRouting>0 then
  IPRoutingLabel.Caption:='Yes'
 else
  IPRoutingLabel.Caption:='No';

 if pFixedInfo.EnableProxy>0 then
  WINSProxyLabel.Caption:='Yes'
 else
  WINSProxyLabel.Caption:='No';

 if pFixedInfo.EnableDns>0 then
  NetBIOSResolutionLabel.Caption:='Yes'
 else
  NetBIOSResolutionLabel.Caption:='No';
end;

procedure TSystemInfoForm.FormShow(Sender: TObject);
var
 Err, AdapterInfoSize:DWORD;
 pFixedInfo:PFIXED_INFO;
 pAdapterInfo, pAdapt:PIP_ADAPTER_INFO;
begin
 PageControl1.ActivePageIndex:=0;
 GetIPInfo;
end;


end.
